<script>
	import CardList from './card-list.svelte'

	let taskFromLocalStorage = JSON.parse(localStorage.getItem('task')) 
	let inProgressFromLocalStorage = JSON.parse(localStorage.getItem('progress')) 
	let doneFromLocalStorage = JSON.parse(localStorage.getItem('done')) 
	
	let taskCards = taskFromLocalStorage ? taskFromLocalStorage : []
	let inProgressCard = inProgressFromLocalStorage ? inProgressFromLocalStorage : []
	let doneCard = doneFromLocalStorage ? doneFromLocalStorage : []

	const KEY = ''

	function handleEventAddCard(event){
		let data = event.detail
		if(data.listName == 'Tasks'){
			taskCards = [...taskCards, {todo : data.todo}]
			localStorage.setItem('task', JSON.stringify(taskCards))
		}else if (data.listName == 'In Progress'){
			inProgressCard = [...inProgressCard, {todo : data.todo}]
			localStorage.setItem('progress', JSON.stringify(inProgressCard))
		}else{
			doneCard = [...doneCard, {todo : data.todo}]
			localStorage.setItem('done', JSON.stringify(doneCard))
		}
	}
	
	function handleEventDeleteCard(event){
		let data = event.detail
		if(data.listName == 'Tasks'){
			taskCards.splice(data.index, 1)
			taskCards = taskCards
			localStorage.setItem('task', JSON.stringify(taskCards))
		}else if (data.listName == 'In Progress'){
			inProgressCard.splice(data.index, 1)
			inProgressCard = inProgressCard
			localStorage.setItem('progress', JSON.stringify(inProgressCard))
		}else{
			doneCard.splice(data.index, 1)
			doneCard = doneCard
			localStorage.setItem('done', JSON.stringify(doneCard))
		}
	}

	function handleEventMoveRight(event){
		let data = event.detail
		if(data.listName == 'Tasks'){
			let cardToMove = taskCards.splice(data.index, 1)
			inProgressCard = [...inProgressCard, cardToMove[0]]
			taskCards = taskCards
			localStorage.setItem('task', JSON.stringify(taskCards))
			localStorage.setItem('progress', JSON.stringify(inProgressCard))
		}else if (data.listName == 'In Progress'){
			let cardToMove = inProgressCard.splice(data.index, 1)
			doneCard = [...doneCard, cardToMove[0]]
			inProgressCard = inProgressCard
			localStorage.setItem('progress', JSON.stringify(inProgressCard))
			localStorage.setItem('done', JSON.stringify(doneCard))
		}
	}

	function handleEventMoveLeft(event){
		let data = event.detail
		if (data.listName == 'In Progress'){
			let cardToMove = inProgressCard.splice(data.index, 1)
			taskCards = [...taskCards, cardToMove[0]]
			inProgressCard = inProgressCard
			localStorage.setItem('progress', JSON.stringify(inProgressCard))
			localStorage.setItem('task', JSON.stringify(taskCards))
		}else if(data.listName == 'Done'){
			let cardToMove = doneCard.splice(data.index, 1)
			inProgressCard = [...inProgressCard, cardToMove[0]]
			doneCard = doneCard
			localStorage.setItem('done', JSON.stringify(doneCard))
			localStorage.setItem('progress', JSON.stringify(inProgressCard))
		}
	}
</script>

<main class="container is-fluid">
	<h1 class="is-size-4 mb-3">TODO APP</h1>
	<div class="columns">
		<CardList 
			cards={taskCards} 
			listName={'Tasks'} 
			on:addCard={handleEventAddCard} 
			on:deleteCard={handleEventDeleteCard}
			on:moveRight={handleEventMoveRight}>
		</CardList>
		<CardList 
			cards={inProgressCard} 
			listName={'In Progress'} 
			on:addCard={handleEventAddCard}
			on:deleteCard={handleEventDeleteCard}
			on:moveRight={handleEventMoveRight}
			on:moveLeft={handleEventMoveLeft}>
		</CardList>
		<CardList 
			cards={doneCard} 
			listName={'Done'} 
			on:addCard={handleEventAddCard}
			on:deleteCard={handleEventDeleteCard}
			on:moveLeft={handleEventMoveLeft}>
		</CardList>
	</div>
</main>

<svelte:head>
	<link rel="stylesheet" href="/bulma.min.css">
	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" integrity="sha384-wvfXpqpZZVQGK6TAh5PVlGOfQNHSoD2xbE+QkPxCAFlNEevoEH3Sl0sibVcOQVnN" crossorigin="anonymous">
</svelte:head>
